<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~create_manual_pool.js,~pools.js" 
	styles="path.css,toolbar.css,~../css/reggie-2.css"
	>
<style>

#pool-table
{
	width: 100%;
}

#pool-name
{
	font-size: 125%;
}

#pool-table th, #pool-table td
{
	text-align: left;
	padding: 2px 0.5em 2px 0.5em;
}

#lib-table table
{
	width: 100%;
	border-collapse: collapse;
}

#lib-table thead, #lib-table tbody
{
	border-bottom-width: 1px;
}

#lib-table th, #lib-table td
{
	text-align: left;
	padding: 2px 0.5em 2px 0.5em;
	border-right-width: 1px;
}

#lib-table tbody#lib-table-rows tr
{
	border-bottom-width: 1px;
	border-bottom-style: dotted;
}

#lib-table tbody#lib-table-rows tr.excluded
{
	font-style: italic;
	color: #666666;
}

#lib-table .check
{
	width: 25px;
	text-align: center;
	border-left: 0;
}

#lib-table .name
{
	width: 12em;
}

#lib-table .barcode
{
	width: 6em;
}

#lib-table .plate
{
	width: 12em;
}

#lib-table .remain
{
	width: 4em;
	text-align: center;
}

#lib-table .adapter
{
	width: 4em;
	text-align: center;
}


#lib-table .molarity
{
	width: 4em;
	text-align: center;
}

#lib-table .volume
{
	width: 4em;
	text-align: center;
}

#lib-table .eb
{
	width: 4em;
	text-align: center;
}

#lib-table .status
{
	width: 20px;
	max-width: 20px;
	background-position: 50% 50%;
	background-repeat: no-repeat;
	border-right: 0;
}

td.volume, span.volume
{
	color: #C80000;
}

td.eb, span.eb
{
	color: #0000C8;
}

#lib-table td.remarks
{
	font-style: italic;
}

#lib-table .warning .status
{
	background-image: url('../images/warning.png');
}

#lib-table .lib-error .status
{
	background-image: url('../images/error.png');
	padding-left: 25px;
	color: #C80000;	
}

#lib-table .lib-error .remarks
{
	color: #C80000;	
}

.wizard.flash-error #lib-table .lib-error .status 
{
	animation: enlarge 1s infinite;
}

.wizard.flash-error #lib-table .lib-error
{
	animation: flash 1s infinite;
}


#lib-table-pool-summary td
{
	font-weight: bold;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Create manual pool" 
		/></p:path>

	<div class="content" id="content">

	<form name="reggie" id="wizard" class="wizard">
	<input type="hidden" name="poolName">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select pool options and libraries</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Target molarity</td>
				<td class="input">
					<select name="target_molarity" id="target_molarity" style="width: 4em;">
					<option value="1">1.0
					<option value="2" selected>2.0
					</select>
					nM
				</td>
				<td class="status" id="target_molarity.status"></td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="prompt">Average volume / lib</td>
				<td class="input">
					<input type="text" class="text" name="target_volume" id="target_volume"
						value="5" style="width: 4em;"> µl (2--20)
				</td>
				<td class="status" id="target_volume.status"></td>
				<td class="help" rowspan="2">
					<span id="target_volume.message" class="message"></span>
					Select a target volume when mixing each lib to 2nM before pooling. 
					Use the <b>Dynamic</b> strategy to prioritize final pool molarity by mixing 
					different volume for each library. Use the <b>Fixed</b> strategy to mix all 
					libraries to the given volume.
				</td>
			</tr>
			<tr>
				<td class="prompt">Mixing strategy</td>
				<td class="input">
					<label><input type="radio" name="mixing_strategy" id="mixing_strategy_dynamic" value="dynamic" checked
						>Dynamic</label>
					<label><input type="radio" name="mixing_strategy" id="mixing_strategy_fixed" value="fixed"
						>Fixed</label>
				</td>
				<td class="status" id="mixing_strategy.status"></td>
			</tr>
			</table>
			
			<tbl:toolbar subclass="topborder bottomborder bg-filled-50">
				<tbl:button 
					id="btnSelectLibraries"
					title="Select libraries&hellip;" 
					image="<%=home+"/images/new.png"%>" 
					tooltip="Select libraries to include in the pool"
				/>
				<tbl:button 
					id="btnRemove"
					title="Remove" 
					image="<%=home+"/images/delete.png"%>" 
					tooltip="Remove the selected libraries from the pool"
				/>
				<tbl:button 
					id="btnTargetVolume"
					title="Separate mix volume&hellip;" 
					image="<%=home+"/images/specimen.png"%>" 
					tooltip="Set volume to use in the pool for separately mixed libraries (dynamic mixing only)" 
				/>
				<tbl:button 
					id="btnComment"
					title="Comments&hellip;" 
					image="<%=home+"/images/comment.png"%>" 
					tooltip="Add a comment to the selected libraries" 
				/>
			</tbl:toolbar>

			<div id="pool-table" class="bottomborder">
			<table>
			<tr>
				<th id="pool-name" style="width: 25%;"></th>
				<td style="border-left: 1px solid #A0A0A0;" rowspan="2">
					<textarea name="poolComments" id="poolComments" style="width: 100%; height: 3.5em;"></textarea>
				</td>
			</tr>
			<tr>
				<td style="width: 25%;" id="pool-summary">0 libs • 0.00nM • 0.0µl</td>
			</tr>
			</table>
			</div>
			
			<div id="lib-table" style="display: none;">
			<div style="margin: 1em;" class="messagecontainer note">
				<base:icon image="info.png"/> 
				<b>Separate mix:</b> <span id="num_separate_mix"></span>, 
				<b>Low quantity:</b> <span id="num_low_quantity"></span>, 
				<b>Excluded:</b> <span id="num_excluded"></span>
			</div>
			<table class="bottomborder topborder">
			<thead class="bg-filled-100">
				<tr>
					<th class="check"></th>
					<th class="name"></th>
					<th class="barcode"></th>
					<th class="plate"></th>
					<th class="remain">Remain</th>
					<th class="adapter">Adapter</th>
					<th class="molarity">DNA</th>
					<th class="volume">Volume</th>
					<th class="eb">EB</th>
					<th class="remarks" colspan="2"></th>
				</tr>
				<tr>
					<th class="check"><base:icon image="check_uncheck.png" tooltip="Check/uncheck all" id="checkAll" /></th>
					<th class="name">Library</th>
					<th class="barcode">Barcode</th>
					<th class="plate">Work plate</th>
					<th class="molarity">(µl)</th>
					<th class="adapter">(%)</th>
					<th class="molarity">(nM)</th>
					<th class="volume">(µl)</th>
					<th class="eb">(µl)</th>
					<th class="remarks" colspan="2">Remarks</th>
				</tr>
			</thead>
			<tbody id="lib-table-rows"></tbody>
			<tbody style="border-bottom: 0;">
				<tr id="lib-table-pool-summary">
					<td colspan="8" class="bg-filled-100" style="text-align: right; border-left: 0;">EB volume to add</td>
					<td class="eb" id="pool.eb"></td>
					<td class="remarks bg-filled-100" id="pool.remarks" colspan="2"></td>
				</tr>
			</tbody>
			</table>
			<div style="margin: 1em; font-style: italic;">
			* Low quantity = The remaining quantity of this library too low to mix to target molarity for the pool.
			</div>
			</div>
			
			<div id="not-selected" class="messagecontainer note">No libraries have been selected</div>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>